package compute

import (
	"context"
	"net/http"

	"repository.basistech.ru/BASIS/decort-golang-sdk/internal/validators"
)

// StartMigrationINRequest struct to start compute for external migration in
type StartMigrationINRequest struct {
	// ID of compute instance
	// Required: true
	ComputeID uint64 `url:"computeId" json:"computeId" validate:"required"`

	// ID of the node where the compute will be staged for migration-in
	// Required: false
	NodeID uint64 `url:"node_id,omitempty" json:"node_id,omitempty"`
}

// StartMigrationIN starts compute for external migration in
func (c Compute) StartMigrationIN(ctx context.Context, req StartRequest) (string, error) {
	err := validators.ValidateRequest(req)
	if err != nil {
		return "", validators.ValidationErrors(validators.GetErrors(err))
	}

	url := "/cloudbroker/compute/start_migration_in"

	res, err := c.client.DecortApiCall(ctx, http.MethodPost, url, req)
	if err != nil {
		return "", err
	}

	return string(res), nil
}
